;City demo by Psyco
;City demo (c) 2003 Farcestudios
;Setup
AppTitle "City Demo"
Graphics3D 1024,768

;car
car = LoadMesh("car.b3d") 
ScaleEntity car,0.3,0.3,0.3
;camera
camera = CreateCamera(car)
CameraViewport camera,0,0,GraphicsWidth(),GraphicsHeight()
CameraClsColor camera,96,96,96
CameraRange camera,0.1,2500
CameraFogMode camera,True
CameraFogColor camera,96,96,96
CameraFogRange camera,128,2500
RotateEntity camera,20,180,0 
MoveEntity camera,0,80,-300 
PositionEntity car,0,-60,0

;variables
setime = MilliSecs()
Speed# = 0
carof# = 0
playerid = 1

;globals
Global brush = CreateBrush()
Global rtextnum = 0
Global fvar = 0
Global sky = CreateMesh()
Global bam = 100000
Global bcon = 0
Global rcon = 0

;arrays
Dim building(bam)
Dim buildx#(bam)
Dim buildz#(bam)
Dim buildsy#(bam)
Dim buildtex(bam)

;textures
textam = 100
Dim texture(textam)
texture(0) = LoadTexture("textures/build01.bmp")
texture(1) = LoadTexture("textures/roof01.jpg")
texture(3) = LoadTexture("textures/build02.jpg")
texture(6) = LoadTexture("textures/iron02.jpg")
texture(14) = LoadTexture("textures/pole02.jpg")
texture(15) = LoadTexture("textures/pole02.jpg")
texture(16) = LoadTexture("textures/dam.jpg")
texture(18) = LoadTexture("textures/build03.jpg")
texture(19) = LoadTexture("textures/build04.jpg")
texture(20) = LoadTexture("textures/factory01.jpg")
texture(21) = LoadTexture("textures/factory02.jpg")
texture(22) = LoadTexture("textures/factory03.jpg")
texture(23) = LoadTexture("textures/factory04.jpg")
texture(24) = LoadTexture("textures/grass01.jpg")
texture(26) = LoadTexture("textures/conc01.jpg")
texture(29) = LoadTexture("textures/build05.jpg")
texture(44) = LoadTexture("textures/roof01.jpg")
texture(50) = LoadTexture("textures/road04.jpg")
texture(52) = LoadTexture("textures/build06.jpg")
texture(53) = LoadTexture("textures/build07.jpg")
texture(54) = LoadTexture("textures/rtile01.bmp")
texture(55) = LoadTexture("textures/rtile01.bmp")
texture(56) = LoadTexture("textures/rtile01.bmp")
texture(57) = LoadTexture("textures/rtile04.bmp")
texture(58) = LoadTexture("textures/rtile05.bmp")
texture(59) = LoadTexture("textures/build10.bmp")
texture(60) = LoadTexture("textures/build11.bmp")
texture(61) = LoadTexture("textures/build12.bmp")
texture(62) = LoadTexture("textures/sign.jpg")
texture(63) = LoadTexture("textures/mail1.bmp")
texture(64) = LoadTexture("textures/mail2.bmp")

;sky
skys()

;buildings
For x = 0 To 50
	rnumc = rnumc + 1
	If rnumc > 1 Then rnumc = 0
	For y = 0 To 50
		rnum = rnum + 1
		If rnum > 1 Then rnum = 0
		grtext()
		If rnum = 0 Then If rnumc = 0 Then skyscraper(x*200,0,y*200,0,rtextnum)
		If rnum = 0 Then If rnumc = 0 Then buildings = buildings + 1
		If rnum = 1 Then If rnumc = 0 Then road(x*200,-40,y*200,0)
		If rnum = 1 Then If rnumc = 1 Then road(x*200,-40,y*200,1)
		If rnum = 0 Then If rnumc = 1 Then road(x*200,-40,y*200,2)
	Next
Next 

;camera mirror
If playerid = 1 Then
	rvmir = CreateCamera(car)
	CameraViewport rvmir,400,40,200,30
	MoveEntity rvmir,0,40,-180 
	CameraClsColor rvmir,96,96,96
	CameraRange rvmir,0.1,2500
	CameraFogMode rvmir,True
	CameraFogColor rvmir,96,96,96
	CameraFogRange rvmir,128,2500
EndIf

setime = (MilliSecs() - setime)/1000
;loop
.loop
If KeyHit(1) Then End

;keys
;All time keys
If KeyHit(28) Then Wire = Not wire
If KeyHit(2) Then screenshot("screen")

;car physics
If playerid = 1 Then
camtx# = EntityX(camera)
camty# = EntityY(camera)
camtz# = EntityZ(camera)
If speed <> 0 Then
	If speed > 0 Then
		If KeyDown (205) Then TurnEntity car,0,1 + speed/15,0
		If KeyDown(203) Then TurnEntity car,0,-1 - speed/15,0
		If KeyDown (205) Then speed = speed - 0.05
		If KeyDown(203) Then speed = speed + 0.05
	EndIf
	If speed < 0 Then
		If KeyDown (203) Then TurnEntity car,0,1 - speed/15,0
		If KeyDown(205) Then TurnEntity car,0,-1 + speed/15,0
		If KeyDown (205) Then speed = speed + 0.05
		If KeyDown(203) Then speed = speed - 0.05
	EndIf
EndIf

If KeyDown (200) Then speed = speed - 0.1
If KeyDown(208) Then speed = speed + 0.1
If KeyDown(57) Then 
	If speed > 0 Then speed = speed - 0.3
	If speed < 0 Then speed = speed + 0.3
	If speed > -0.3 Then If speed < 0.3 Then speed = 0
EndIf

If speed > 30 Then speed = 30
If speed < -30 Then speed = -30
If speed > - 0.1 Then If speed < 0.1 Then speed = 0
MoveEntity car,0,0,speed

If Not KeyDown(200) Then If Not KeyDown(208) Then
If speed < 0 Then speed = speed + 0.1
If speed > 0 Then speed = speed - 0.1
EndIf

EndIf

;plane physics
If playerid = 2 Then
camtx# = EntityX(camera)
camty# = EntityY(camera)
camtz# = EntityZ(camera)
If KeyDown (203) Then TurnEntity car,0,0,5
If KeyDown(205) Then TurnEntity car,0,0,-5
If KeyDown (200) Then TurnEntity car,-3,0,0
If KeyDown(208) Then TurnEntity car,3,0,0

If KeyDown(30) Then speed = speed + 0.2
If KeyDown(44) Then speed = speed - 0.2

If KeyDown(57) Then 
	If speed > 0 Then speed = speed - 0.3
	If speed < 0 Then speed = speed + 0.3
	If speed > -0.3 Then If speed < 0.3 Then speed = 0
EndIf

If speed > 30 Then speed = 30
If speed < 1 Then speed = 1
If speed > - 0.1 Then If speed < 0.1 Then speed = 0
MoveEntity car,0,0,-speed

;mouse
campch# = 0
camyaw# = 0
If cmx < MouseX() Then camyaw = (cmx - MouseX())/2
If cmx > MouseX() Then camyaw = (cmx - MouseX())/2
If cmy < MouseY() Then campch = (MouseY() - cmy)/2
If cmy > MouseY() Then campch = (MouseY() - cmy)/2
MoveMouse 400,300
cmx = MouseX()
cmy = MouseY()
EndIf

;controll
;camera
TurnEntity car,campch,camyaw,0
If EntityY(car) < -80 Then PositionEntity car,EntityX(car),-80,EntityZ(car)

;sky
PositionEntity sky,EntityX(camera),EntityY(camera) +  500,EntityZ(camera)

;wireframe
If wire = 0 Then WireFrame False Else WireFrame True

;fps
FPSframes=FPSframes+1
If MilliSecs()>FPSmillis+1000 Then
	FPS=FPSframes
	FPSmillis=MilliSecs()
	FPSframes=0
End If

;stuff

UpdateWorld
RenderWorld

;2d stuff
Text 0,0,"Took "+setime+" seconds to load"
Text 0,10,"Buildings:" + bcon
Text 0,20,"FPS: "+fps
Text 0,30,"Camera: "
Text 0,40,"x: "+EntityX(camera)
Text 0,50,"y: "+EntityY(camera)
Text 0,60,"z: "+EntityZ(camera)
Text 0,70,"Speed: "+speed#
Text 0,80,"Carof: "+Carof#

Flip
Cls
Goto loop

;functions
;skyscraper
Function skyscraper(x#,y#,z#,ty,tex)
	If ty = 0 Then
		fvar2 = Rand(100)
		If fvar2 <> 50 Then
		building(bcon) = CreateMesh()
		BrushTexture brush,texture(tex)
		addface(2)
		addface(3)
		addface(4)
		addface(5)
		
		BrushTexture brush,texture(1)	
		addface(0)
			
		;finish
		fvar = Rand(100)
		PositionEntity building(bcon),x,y + fvar + 60,z
		ScaleEntity building(bcon),100,150 + fvar,100
		bcon = bcon + 1
		
		;path
		building(bcon) = CreateMesh()
		BrushTexture brush,texture(26)

		addface(0)
		addface(2)
		addface(3)
		addface(4)
		addface(5)
				
		;finish
		PositionEntity building(bcon),x,y - 90,z
		ScaleEntity building(bcon),140,10,140
		bcon = bcon + 1
		EndIf
		
		If fvar2 = 50 Then 
			building(bcon) = CreateMesh()
			BrushTexture brush,texture(24)
			
			addface(1)
			FlipMesh(building(bcon))
			;finish
			PositionEntity building(bcon),x,y - 69,z
			ScaleEntity building(bcon),100,10,100

		;path
		building(bcon) = CreateMesh()
		BrushTexture brush,texture(26)

		addface(0)
		addface(2)
		addface(3)
		addface(4)
		addface(5)
				
		;finish
		PositionEntity building(bcon),x,y - 90,z
		ScaleEntity building(bcon),140,10,140
		bcon = bcon + 1
		
		EndIf
		
		;Sign
		fvar = Rand(6)
		If fvar = 1 Then 
			building(bcon) = CreateMesh()
			BrushTexture brush,texture(14)
		
			addface(0)
			addface(2)
			addface(3)
			addface(4)
			addface(5)	
	
			;finish
			PositionEntity building(bcon),x + 130,y - 98,z + 130
			ScaleEntity building(bcon),2,75,2
			bcon = bcon + 1
			
			;sign
			building(bcon) = CreateMesh()
			BrushTexture brush,texture(6)
		
			addface(4)
			
			FlipMesh(building(bcon))
			BrushTexture brush,texture(62)
			addface(4)
			
			;finish
			PositionEntity building(bcon),x + 130,y - 30,z + 131.9
			ScaleEntity building(bcon),5,10,5
			bcon = bcon + 1			
		EndIf
		;power poles
		If fvar = 2 Then 
			building(bcon) = CreateMesh()
			BrushTexture brush,texture(54)
			addface(0)	
			
			FlipMesh(building(bcon))
			
			addface(0)
			
			;finish
			PositionEntity building(bcon),x + 200,y + 150,z + 90
			ScaleEntity building(bcon),100,1,1
			bcon = bcon + 1	

			building(bcon) = CreateMesh()
			BrushTexture brush,texture(54)
			addface(0)	
			
			FlipMesh(building(bcon))
			
			addface(0)
			
			;finish
			PositionEntity building(bcon),x + 200,y + 150,z + 95
			ScaleEntity building(bcon),100,1,1
			bcon = bcon + 1		
		EndIf
		;power poles 2
		If fvar = 3 Then 
			building(bcon) = CreateMesh()
			BrushTexture brush,texture(54)
			addface(0)	
			
			FlipMesh(building(bcon))
			
			addface(0)
			
			;finish
			PositionEntity building(bcon),x + 200,y + 80,z + 90
			ScaleEntity building(bcon),100,1,1
			bcon = bcon + 1	

			building(bcon) = CreateMesh()
			BrushTexture brush,texture(54)
			addface(0)	
			
			FlipMesh(building(bcon))
			
			addface(0)
			
			;finish
			PositionEntity building(bcon),x + 200,y + 80,z + 95
			ScaleEntity building(bcon),100,1,1
			bcon = bcon + 1		
		EndIf
		;power poles 3
		If fvar = 4 Then 
			building(bcon) = CreateMesh()
			BrushTexture brush,texture(54)
			addface(0)
			FlipMesh(building(bcon))
			addface(0)

			
			;finish
			RotateEntity building(bcon),90,0,90
			PositionEntity building(bcon),x + 95,y + 150,z + 200
			ScaleEntity building(bcon),100,1,1
			bcon = bcon + 1	

			building(bcon) = CreateMesh()
			BrushTexture brush,texture(54)
			addface(0)
			FlipMesh(building(bcon))
			addface(0)
			
			;finish
			RotateEntity building(bcon),90,0,90
			PositionEntity building(bcon),x + 90,y + 150,z + 200
			ScaleEntity building(bcon),100,1,1
			bcon = bcon + 1		
		EndIf
		;postbox
		If fvar = 5 Then 
			building(bcon) = CreateMesh()
			BrushTexture brush,texture(63)
			addface(4)
			addface(5)

			BrushTexture brush,texture(64)	
			addface(2)
			addface(3)
		
			BrushTexture brush,texture(63)
			addface(0)
			
			;finish
			PositionEntity building(bcon),x + 128,y - 60,z + 128
			ScaleEntity building(bcon),10,20,10
			bcon = bcon + 1
		EndIf
		;lamp
		If fvar = 6 Then 
			building(bcon) = CreateMesh()
			BrushTexture brush,texture(14)
			addface(4)
			addface(5)
			addface(2)
			addface(3)
			addface(0)	
			
			;finish
			PositionEntity building(bcon),x + 128,y - 40,z + 128
			ScaleEntity building(bcon),2,40,2
			bcon = bcon + 1
			
			;top
			building(bcon) = CreateMesh()
			BrushTexture brush,texture(14)
		
			addface(0)
			addface(1)
			addface(2)
			addface(3)
			addface(4)
			addface(5)
			
			;finish
			PositionEntity building(bcon),x + 128,y,z + 128
			ScaleEntity building(bcon),4,5,4
			bcon = bcon + 1
		EndIf
	EndIf
	If ty = 1 Then 
		building(bcon) = CreateMesh()
		BrushTexture brush,texture(tex)
		addface(2)
		addface(3)
		addface(4)
		addface(5)
		
		BrushTexture brush,texture(1)	
		addface(0)
			
		;finish
		fvar = Rand(100)
		PositionEntity building(bcon),x,y + fvar + 60,z
		ScaleEntity building(bcon),140,150 + fvar,140
		bcon = bcon + 1
		
		;path
		building(bcon) = CreateMesh()
		BrushTexture brush,texture(26)

		addface(0)
		addface(2)
		addface(3)
		addface(4)
		addface(5)
				
		;finish
		PositionEntity building(bcon),x,y - 90,z
		ScaleEntity building(bcon),140,10,140
		bcon = bcon + 1
	EndIf
End Function

;road
Function road(x#,y#,z#,ty)
	If ty = 0 Then
		building(bcon) = CreateMesh()
		BrushTexture brush,texture(56)
		fvar = Rand(5) 
		If fvar = 1 Then BrushTexture brush,texture(57)
		;face
		surface = CreateSurface(building(bcon),brush)
		AddVertex surface,-1,+1,+1,0,1
		AddVertex surface,+1,+1,+1,0,0
		AddVertex surface,+1,+1,-1,1,0
		AddVertex surface,-1,+1,-1,1,1
		AddTriangle surface,0,1,2
		AddTriangle surface,0,2,3
		;setup
		PositionEntity building(bcon),x,y - 50,z
		ScaleEntity building(bcon),100,1,100
		bcon = bcon + 1	
	EndIf
	If ty = 1 Then
		building(bcon) = CreateMesh()
 		brush = CreateBrush()
		BrushTexture brush,texture(55)
		fvar = Rand(5) 
		If fvar = 1 Then BrushTexture brush,texture(58)
		;face
		surface = CreateSurface(building(bcon),brush)
		AddVertex surface,-1,+1,+1,0,1
		AddVertex surface,+1,+1,+1,0,0
		AddVertex surface,+1,+1,-1,1,0
		AddVertex surface,-1,+1,-1,1,1
		AddTriangle surface,0,1,2
		AddTriangle surface,0,2,3
		;setup
		PositionEntity building(bcon),x,y - 50,z
		ScaleEntity building(bcon),100,1,100
		bcon = bcon + 1	
	EndIf
	If ty = 2 Then
		building(bcon) = CreateMesh()
 		brush = CreateBrush()
		BrushTexture brush,texture(54)
		;face
		surface = CreateSurface(building(bcon),brush)
		AddVertex surface,-1,+1,+1,0,1
		AddVertex surface,+1,+1,+1,0,0
		AddVertex surface,+1,+1,-1,1,0
		AddVertex surface,-1,+1,-1,1,1
		AddTriangle surface,0,1,2
		AddTriangle surface,0,2,3
		;setup
		PositionEntity building(bcon),x,y - 50,z
		ScaleEntity building(bcon),100,1,100
		bcon = bcon + 1	
	EndIf
End Function

;take screenshot
Function screenshot(name$)
	SaveBuffer(FrontBuffer(),""+name$+".bmp")
End Function

;get a random texture for the buildings
Function grtext()
	rvar = Rand(13)
	If rvar = 0 Then rtextnum = 0
	If rvar = 1 Then rtextnum = 3
	If rvar = 2 Then rtextnum = 18
	If rvar = 3 Then rtextnum = 16
	If rvar = 4 Then rtextnum = 20
	If rvar = 5 Then rtextnum = 21
	If rvar = 6 Then rtextnum = 22
	If rvar = 7 Then rtextnum = 23
	If rvar = 8 Then rtextnum = 29
	If rvar = 9 Then rtextnum = 52
	If rvar = 10 Then rtextnum = 53
	If rvar = 11 Then rtextnum = 59
	If rvar = 12 Then rtextnum = 60
	If rvar = 13 Then rtextnum = 61
End Function

;sky
Function skys()
	skytext = LoadTexture("textures/sky.jpg") 
	BrushTexture brush,skytext

	;top face
	surface = CreateSurface(sky,brush)
	AddVertex surface,-1,+1,+1,0,1
	AddVertex surface,+1,+1,+1,0,0
	AddVertex surface,+1,+1,-1,1,0
	AddVertex surface,-1,+1,-1,1,1
	AddTriangle surface,0,1,2
	AddTriangle surface,0,2,3
		
	FlipMesh sky
	PositionEntity sky,-500,500,-500
	ScaleEntity sky,5000,1,5000
End Function

;add faces
Function addface(face)
	If face = 0 Then
		surface = CreateSurface(building(bcon),brush)
		AddVertex surface,-1,+1,+1,0,1
		AddVertex surface,+1,+1,+1,0,0
		AddVertex surface,+1,+1,-1,1,0
		AddVertex surface,-1,+1,-1,1,1
		AddTriangle surface,0,1,2
		AddTriangle surface,0,2,3		
	EndIf	
	If face = 1 Then
		surface = CreateSurface(building(bcon),brush)
		AddVertex surface,-1,-1,-1,1,0
		AddVertex surface,+1,-1,-1,1,1
		AddVertex surface,+1,-1,+1,0,1
		AddVertex surface,-1,-1,+1,0,0
		AddTriangle surface,0,1,2
		AddTriangle surface,0,2,3
	EndIf
	If face = 2 Then
		surface = CreateSurface(building(bcon),brush)
		AddVertex surface,-1,+1,+1,0,0
		AddVertex surface,-1,+1,-1,1,0
		AddVertex surface,-1,-1,-1,1,1
		AddVertex surface,-1,-1,+1,0,1
		AddTriangle surface,0,1,2
		AddTriangle surface,0,2,3	
	EndIf
	If face = 3 Then
		surface = CreateSurface(building(bcon),brush)
		AddVertex surface,+1,+1,-1,0,0
		AddVertex surface,+1,+1,+1,1,0
		AddVertex surface,+1,-1,+1,1,1
		AddVertex surface,+1,-1,-1,0,1
		AddTriangle surface,0,1,2
		AddTriangle surface,0,2,3
	EndIf
	If face = 4 Then
		surface = CreateSurface(building(bcon),brush)
		AddVertex surface,-1,+1,-1,0,0
		AddVertex surface,+1,+1,-1,1,0
		AddVertex surface,+1,-1,-1,1,1
		AddVertex surface,-1,-1,-1,0,1
		AddTriangle surface,0,1,2
		AddTriangle surface,0,2,3	
	EndIf
	If face = 5 Then
		surface = CreateSurface(building(bcon),brush)
		AddVertex surface,+1,+1,+1,0,0
		AddVertex surface,-1,+1,+1,1,0
		AddVertex surface,-1,-1,+1,1,1
		AddVertex surface,+1,-1,+1,0,1
		AddTriangle surface,0,1,2
		AddTriangle surface,0,2,3
	EndIf
End Function